-- lalonde
-- Copyright (C) 2010 Noé Falzon <firstname.lastname@aliceadsl.fr>

-- This program is  free software:  you can redistribute it and/or modify it
-- under  the terms  of the  GNU General Public License  as published by the
-- Free Software Foundation, version 3 of the License.
--
-- This program  is  distributed  in the hope  that it will  be useful,  but
-- WITHOUT  ANY WARRANTY;  without  even the implied  warranty of MERCHANTA-
-- BILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
-- License for more details.
--
-- You should have received a copy of the  GNU General Public License  along
-- with this program. If not, see <http://www.gnu.org/licenses/>.

package.path = package.path .. ";../common/?.lua"

require "TcpClient"

init = function(w,h)
	
	screen = ""
	
	Net = TcpClient(server,port,0)
	
	Net.cbrecv = cbrecv
	Net.cbdisconnect = cbdisconnect 
	
	if not Net.socket then
		print("Couldn't connect to " .. server .. ":" .. port)
		return false
	end
	
	print("Connected to " .. Net.ip .. ":" .. Net.port)
	
	-- Send terminal size and username
	Net:send("nick " .. nick)
	Net:send("tsize " .. w .." " .. h)
		
	return true
end

-- protocol is: if the key press gave a unicode codepoint, send it
-- else, send 'k' followed by the keysym

-- (the keysym itself is negative if it is a keyup)

-- exception for the few keys that produce invisible unicode control chars
-- mostly: escape, tab, backspace, return (with codes < 32), del (127)

input = function(k,uni)
	
	local send = (uni and uni >= 32 and uni ~= 127) and uni or 'k' .. k
	Net:send(send)
	
end

cbrecv = function(data)
	
	screen = data
end

cbdisconnect = function()
		
	disco = true
end

update = function()
	
	Net:update()
end
