-- lalonde
-- Copyright (C) 2010 Noé Falzon <firstname.lastname@aliceadsl.fr>

-- This program is  free software:  you can redistribute it and/or modify it
-- under  the terms  of the  GNU General Public License  as published by the
-- Free Software Foundation, version 3 of the License.
--
-- This program  is  distributed  in the hope  that it will  be useful,  but
-- WITHOUT  ANY WARRANTY;  without  even the implied  warranty of MERCHANTA-
-- BILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
-- License for more details.
--
-- You should have received a copy of the  GNU General Public License  along
-- with this program. If not, see <http://www.gnu.org/licenses/>.

require "class"

require "Client"

ClientManager = class()

function ClientManager:init()
	
	self.clients = {}
	
	return self
end


function ClientManager:addclient(sock)

	local cli = Client(sock)

	self.clients[sock] = cli
	
	print(cli.name .. " connected")
end

-- Forward net input to the relevent Client
function ClientManager:input(data,sock)
	
	local cli = self.clients[sock]
	
	cli:input(data)
end

function ClientManager:removeclient(sock)
			
	local cli = self.clients[sock]
	
	cli:cleanup()
	
	print(cli.name .. " disconnected")
	
	self.clients[sock] = nil
	
	Lalonde.Net:removeclient(sock)
end

function ClientManager:updateall()
	
	for _,cli in pairs(self.clients) do
		
		local disco = cli:update()
		
		if disco then
			self:removeclient(cli.sock)
		end
	end
end
