-- lalonde
-- Copyright (C) 2010 Noé Falzon <firstname.lastname@aliceadsl.fr>

-- This program is  free software:  you can redistribute it and/or modify it
-- under  the terms  of the  GNU General Public License  as published by the
-- Free Software Foundation, version 3 of the License.
--
-- This program  is  distributed  in the hope  that it will  be useful,  but
-- WITHOUT  ANY WARRANTY;  without  even the implied  warranty of MERCHANTA-
-- BILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
-- License for more details.
--
-- You should have received a copy of the  GNU General Public License  along
-- with this program. If not, see <http://www.gnu.org/licenses/>.

-- This is a direct translation of SDL's keysym definitions in SDL's keysym.h

-- keysyms definitions

-- the keyboard syms have been cleverly chosen to map to acsii
keys = {}

keys.unknown = 0
keys.first = 0
keys.backspace = 8
keys.tab = 9
keys.clear = 12
keys['return'] = 13
keys.pause = 19
keys.escape = 27
keys.space = 32
keys.exclaim = 33
keys.quotedbl = 34
keys.hash = 35
keys.dollar = 36
keys.ampersand = 38
keys.quote = 39
keys.leftparen = 40
keys.rightparen = 41
keys.asterisk = 42
keys.plus = 43
keys.comma = 44
keys.minus = 45
keys.period = 46
keys.slash = 47
keys['0'] = 48
keys['1'] = 49
keys['2'] = 50
keys['3'] = 51
keys['4'] = 52
keys['5'] = 53
keys['6'] = 54
keys['7'] = 55
keys['8'] = 56
keys['9'] = 57
keys.colon = 58
keys.semicolon = 59
keys.less = 60
keys.equals = 61
keys.greater = 62
keys.question = 63
keys.at = 64

-- skip uppercase letters

keys.leftbracket = 91
keys.backslash = 92
keys.rightbracket = 93
keys.caret = 94
keys.underscore = 95
keys.backquote = 96
keys.a = 97
keys.b = 98
keys.c = 99
keys.d = 100
keys.e = 101
keys.f = 102
keys.g = 103
keys.h = 104
keys.i = 105
keys.j = 106
keys.k = 107
keys.l = 108
keys.m = 109
keys.n = 110
keys.o = 111
keys.p = 112
keys.q = 113
keys.r = 114
keys.s = 115
keys.t = 116
keys.u = 117
keys.v = 118
keys.w = 119
keys.x = 120
keys.y = 121
keys.z = 122
keys.delete = 127
-- end of ascii mapped keysyms

-- international keyboard syms
keys.world_0 = 160 -- 0xa0
keys.world_1 = 161
keys.world_2 = 162
keys.world_3 = 163
keys.world_4 = 164
keys.world_5 = 165
keys.world_6 = 166
keys.world_7 = 167
keys.world_8 = 168
keys.world_9 = 169
keys.world_10 = 170
keys.world_11 = 171
keys.world_12 = 172
keys.world_13 = 173
keys.world_14 = 174
keys.world_15 = 175
keys.world_16 = 176
keys.world_17 = 177
keys.world_18 = 178
keys.world_19 = 179
keys.world_20 = 180
keys.world_21 = 181
keys.world_22 = 182
keys.world_23 = 183
keys.world_24 = 184
keys.world_25 = 185
keys.world_26 = 186
keys.world_27 = 187
keys.world_28 = 188
keys.world_29 = 189
keys.world_30 = 190
keys.world_31 = 191
keys.world_32 = 192
keys.world_33 = 193
keys.world_34 = 194
keys.world_35 = 195
keys.world_36 = 196
keys.world_37 = 197
keys.world_38 = 198
keys.world_39 = 199
keys.world_40 = 200
keys.world_41 = 201
keys.world_42 = 202
keys.world_43 = 203
keys.world_44 = 204
keys.world_45 = 205
keys.world_46 = 206
keys.world_47 = 207
keys.world_48 = 208
keys.world_49 = 209
keys.world_50 = 210
keys.world_51 = 211
keys.world_52 = 212
keys.world_53 = 213
keys.world_54 = 214
keys.world_55 = 215
keys.world_56 = 216
keys.world_57 = 217
keys.world_58 = 218
keys.world_59 = 219
keys.world_60 = 220
keys.world_61 = 221
keys.world_62 = 222
keys.world_63 = 223
keys.world_64 = 224
keys.world_65 = 225
keys.world_66 = 226
keys.world_67 = 227
keys.world_68 = 228
keys.world_69 = 229
keys.world_70 = 230
keys.world_71 = 231
keys.world_72 = 232
keys.world_73 = 233
keys.world_74 = 234
keys.world_75 = 235
keys.world_76 = 236
keys.world_77 = 237
keys.world_78 = 238
keys.world_79 = 239
keys.world_80 = 240
keys.world_81 = 241
keys.world_82 = 242
keys.world_83 = 243
keys.world_84 = 244
keys.world_85 = 245
keys.world_86 = 246
keys.world_87 = 247
keys.world_88 = 248
keys.world_89 = 249
keys.world_90 = 250
keys.world_91 = 251
keys.world_92 = 252
keys.world_93 = 253
keys.world_94 = 254
keys.world_95 = 255 -- 0xff

-- numeric keypad
keys.kp0 = 256
keys.kp1 = 257
keys.kp2 = 258
keys.kp3 = 259
keys.kp4 = 260
keys.kp5 = 261
keys.kp6 = 262
keys.kp7 = 263
keys.kp8 = 264
keys.kp9 = 265
keys.kp_period = 266
keys.kp_divide = 267
keys.kp_multiply = 268
keys.kp_minus = 269
keys.kp_plus = 270
keys.kp_enter = 271
keys.kp_equals = 272

-- arrows + home/end pad
keys.up = 273
keys.down = 274
keys.right = 275
keys.left = 276
keys.insert = 277
keys.home = 278
keys['end'] = 279
keys.pageup = 280
keys.pagedown = 281

-- function keys
keys.f1 = 282
keys.f2 = 283
keys.f3 = 284
keys.f4 = 285
keys.f5 = 286
keys.f6 = 287
keys.f7 = 288
keys.f8 = 289
keys.f9 = 290
keys.f10 = 291
keys.f11 = 292
keys.f12 = 293
keys.f13 = 294
keys.f14 = 295
keys.f15 = 296

-- key state modifier keys
keys.numlock = 300
keys.capslock = 301
keys.scrollock = 302
keys.rshift = 303
keys.lshift = 304
keys.rctrl = 305
keys.lctrl = 306
keys.ralt = 307
keys.lalt = 308
keys.rmeta = 309
keys.lmeta = 310
keys.lsuper = 311
keys.rsuper = 312
keys.mode = 313
keys.compose = 314

-- miscellaneous function keys
keys.help = 315
keys.print = 316
keys.sysreq = 317
keys['break'] = 318
keys.menu = 319
keys.power = 320 -- power macintosh power key
keys.euro = 321 -- some european keyboards
keys.undo = 322 -- atari keyboard has undo


-- reverse table, stored in the same place

keys[0] = 'first'
keys[8] = 'backspace'
keys[9] = 'tab'
keys[12] = 'clear'
keys[13] = 'return'
keys[19] = 'pause'
keys[27] = 'escape'
keys[32] = 'space'
keys[33] = 'exclaim'
keys[34] = 'quotedbl'
keys[35] = 'hash'
keys[36] = 'dollar'
keys[38] = 'ampersand'
keys[39] = 'quote'
keys[40] = 'leftparen'
keys[41] = 'rightparen'
keys[42] = 'asterisk'
keys[43] = 'plus'
keys[44] = 'comma'
keys[45] = 'minus'
keys[46] = 'period'
keys[47] = 'slash'
keys[48] = '0'
keys[49] = '1'
keys[50] = '2'
keys[51] = '3'
keys[52] = '4'
keys[53] = '5'
keys[54] = '6'
keys[55] = '7'
keys[56] = '8'
keys[57] = '9'
keys[58] = 'colon'
keys[59] = 'semicolon'
keys[60] = 'less'
keys[61] = 'equals'
keys[62] = 'greater'
keys[63] = 'question'
keys[64] = 'at'
keys[91] = 'leftbracket'
keys[92] = 'backslash'
keys[93] = 'rightbracket'
keys[94] = 'caret'
keys[95] = 'underscore'
keys[96] = 'backquote'
keys[97] = 'a'
keys[98] = 'b'
keys[99] = 'c'
keys[100] = 'd'
keys[101] = 'e'
keys[102] = 'f'
keys[103] = 'g'
keys[104] = 'h'
keys[105] = 'i'
keys[106] = 'j'
keys[107] = 'k'
keys[108] = 'l'
keys[109] = 'm'
keys[110] = 'n'
keys[111] = 'o'
keys[112] = 'p'
keys[113] = 'q'
keys[114] = 'r'
keys[115] = 's'
keys[116] = 't'
keys[117] = 'u'
keys[118] = 'v'
keys[119] = 'w'
keys[120] = 'x'
keys[121] = 'y'
keys[122] = 'z'
keys[127] = 'delete'
keys[160] = 'world_0'
keys[161] = 'world_1'
keys[162] = 'world_2'
keys[163] = 'world_3'
keys[164] = 'world_4'
keys[165] = 'world_5'
keys[166] = 'world_6'
keys[167] = 'world_7'
keys[168] = 'world_8'
keys[169] = 'world_9'
keys[170] = 'world_10'
keys[171] = 'world_11'
keys[172] = 'world_12'
keys[173] = 'world_13'
keys[174] = 'world_14'
keys[175] = 'world_15'
keys[176] = 'world_16'
keys[177] = 'world_17'
keys[178] = 'world_18'
keys[179] = 'world_19'
keys[180] = 'world_20'
keys[181] = 'world_21'
keys[182] = 'world_22'
keys[183] = 'world_23'
keys[184] = 'world_24'
keys[185] = 'world_25'
keys[186] = 'world_26'
keys[187] = 'world_27'
keys[188] = 'world_28'
keys[189] = 'world_29'
keys[190] = 'world_30'
keys[191] = 'world_31'
keys[192] = 'world_32'
keys[193] = 'world_33'
keys[194] = 'world_34'
keys[195] = 'world_35'
keys[196] = 'world_36'
keys[197] = 'world_37'
keys[198] = 'world_38'
keys[199] = 'world_39'
keys[200] = 'world_40'
keys[201] = 'world_41'
keys[202] = 'world_42'
keys[203] = 'world_43'
keys[204] = 'world_44'
keys[205] = 'world_45'
keys[206] = 'world_46'
keys[207] = 'world_47'
keys[208] = 'world_48'
keys[209] = 'world_49'
keys[210] = 'world_50'
keys[211] = 'world_51'
keys[212] = 'world_52'
keys[213] = 'world_53'
keys[214] = 'world_54'
keys[215] = 'world_55'
keys[216] = 'world_56'
keys[217] = 'world_57'
keys[218] = 'world_58'
keys[219] = 'world_59'
keys[220] = 'world_60'
keys[221] = 'world_61'
keys[222] = 'world_62'
keys[223] = 'world_63'
keys[224] = 'world_64'
keys[225] = 'world_65'
keys[226] = 'world_66'
keys[227] = 'world_67'
keys[228] = 'world_68'
keys[229] = 'world_69'
keys[230] = 'world_70'
keys[231] = 'world_71'
keys[232] = 'world_72'
keys[233] = 'world_73'
keys[234] = 'world_74'
keys[235] = 'world_75'
keys[236] = 'world_76'
keys[237] = 'world_77'
keys[238] = 'world_78'
keys[239] = 'world_79'
keys[240] = 'world_80'
keys[241] = 'world_81'
keys[242] = 'world_82'
keys[243] = 'world_83'
keys[244] = 'world_84'
keys[245] = 'world_85'
keys[246] = 'world_86'
keys[247] = 'world_87'
keys[248] = 'world_88'
keys[249] = 'world_89'
keys[250] = 'world_90'
keys[251] = 'world_91'
keys[252] = 'world_92'
keys[253] = 'world_93'
keys[254] = 'world_94'
keys[255] = 'world_95'
keys[256] = 'kp0'
keys[257] = 'kp1'
keys[258] = 'kp2'
keys[259] = 'kp3'
keys[260] = 'kp4'
keys[261] = 'kp5'
keys[262] = 'kp6'
keys[263] = 'kp7'
keys[264] = 'kp8'
keys[265] = 'kp9'
keys[266] = 'kp_period'
keys[267] = 'kp_divide'
keys[268] = 'kp_multiply'
keys[269] = 'kp_minus'
keys[270] = 'kp_plus'
keys[271] = 'kp_enter'
keys[272] = 'kp_equals'
keys[273] = 'up'
keys[274] = 'down'
keys[275] = 'right'
keys[276] = 'left'
keys[277] = 'insert'
keys[278] = 'home'
keys[279] = 'end'
keys[280] = 'pageup'
keys[281] = 'pagedown'
keys[282] = 'f1'
keys[283] = 'f2'
keys[284] = 'f3'
keys[285] = 'f4'
keys[286] = 'f5'
keys[287] = 'f6'
keys[288] = 'f7'
keys[289] = 'f8'
keys[290] = 'f9'
keys[291] = 'f10'
keys[292] = 'f11'
keys[293] = 'f12'
keys[294] = 'f13'
keys[295] = 'f14'
keys[296] = 'f15'
keys[300] = 'numlock'
keys[301] = 'capslock'
keys[302] = 'scrollock'
keys[303] = 'rshift'
keys[304] = 'lshift'
keys[305] = 'rctrl'
keys[306] = 'lctrl'
keys[307] = 'ralt'
keys[308] = 'lalt'
keys[309] = 'rmeta'
keys[310] = 'lmeta'
keys[311] = 'lsuper'
keys[312] = 'rsuper'
keys[313] = 'mode'
keys[314] = 'compose'
keys[315] = 'help'
keys[316] = 'print'
keys[317] = 'sysreq'
keys[318] = 'break'
keys[319] = 'menu'
keys[320] = 'power'
keys[321] = 'euro'
keys[322] = 'undo'
